package fccsc.manager.data.process;

import intarsys.util.*;

import fccsc.manager.broker.*;
import fccsc.manager.data.*;
import fccsc.manager.data.edi.*;


public final class Verify
	extends ProcessFEDI
{
	/**
	 * Creates an object to process VERIFY messages.
	 */
    public
	Verify()
    {
		super( "message.VERIFY.properties" );
    }


	/**
	 * Interface Method - Processing method.
	 * @throws Exception
	 */
	public void
	process() throws Exception
	{
		super.process();

		String studId  = this.getEDIStandardDataBlock().getStudentID();
		String studPwd = this.getEDIStandardDataBlock().getPinPassword();
		String term    = "";

		studId  = (String) StringTools.padRight( studId,  9, ' ' );
		studPwd = (String) StringTools.padRight( studPwd, 6, ' ' );
		term    = (String) StringTools.padRight(      "", 6, ' ' );

		String data = studId + studPwd + term;

		EntireXBroker broker = new EntireXBroker( this.getProperties() );
		broker.sendMessage( data );

		// get response message
		String response     = (String) broker.getResponse();
		String resRC        = (String) response.substring( 96,   96 + 4   );
		String resDemoGrafx = (String) response.substring( 100, 100 + 240 );

		if ( logger.isDebugEnabled() )
		{
			logger.debug( "Broker Response [" + response + "]" );
		}

		if ( resRC.equalsIgnoreCase( "0000" ) )
		{
		    resRC = ReturnCodes.CODE_00000;
		}

		if ( resDemoGrafx.trim().length() == 0 )
		{
		    resRC        = ReturnCodes.CODE_00048;
			resDemoGrafx = ReturnCodes.CODE_00048_MESSAGE;

			logger.error( "Error [" + resRC + " - " + resDemoGrafx + "]" );
		}

		this.getEDIStandardDataBlock().setReturnCode(    resRC );
		this.getEDIStandardDataBlock().setReturnMessage( resDemoGrafx );


		this.setResponse(   (String) this.getEDIControlBlock().getData() +
									 this.getEDIStandardDataBlock().getData() );
	}
}